%global pkgvers 0
%global scdate0 20230831
%global schash0 36a27981b36cb30765796080a5a5fb1270a0ea65
%global branch0 master
%global source0 https://github.com/gatecat/prjoxide.git

%global scdate1 20220810
%global schash1 56009be1ca77a7123ffdb50a813216302a42ac27
%global branch1 master
%global source1 https://github.com/gatecat/prjoxide-db.git

%global sshort0 %{expand:%%{lua:print(('%{schash0}'):sub(1,8))}}

Name:           prjoxide
Version:        0
Release:        %{scdate0}.%{pkgvers}.git%{sshort0}%{?dist}
Summary:        Lattice Nexus FPGA bitstream tools
License:        ISC
URL:            https://github.com/gatecat/prjoxide

BuildRequires:  python3 git cargo

Requires:       %{name}-data = %{version}-%{release}

%description
Project oxide enables a fully open-source flow for
Lattice's 28nm "Nexus" FPGA parts.


%package        devel
Summary:        Development files for Project %{name}
Requires:       %{name}-data = %{version}-%{release}

%description    devel
Development files to build packages using Project %{name}


%package        data
Summary:        Project %{name} database
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description    data
This package contains the bitstream database for %{name}


%prep
%setup -T -c -n %{name}
find %{_builddir} -name SPECPARTS -exec rm -rf {} +
git clone --depth 1 -n -b %{branch0} %{source0} .
git fetch --depth 1 origin %{schash0}
git reset --hard %{schash0}
git log --format=fuller
rm -rf database
git clone --depth 1 -n -b %{branch1} %{source1} database
pushd database
git fetch --depth 1 origin %{schash1}
git reset --hard %{schash1}
git log --format=fuller
popd

%build
sed -i 's|clap = "3.0.0-beta.2"|clap = "=3.0.0-beta.2"\nclap_derive = "=3.0.0-beta.2"|' libprjoxide/prjoxide/Cargo.toml
pushd libprjoxide
export RUSTFLAGS="-g"
export CARGO_HOME="%{_builddir}/%{name}/.cargo"
cargo build --release
popd


%install
rm -rf %{buildroot}

# libs
mkdir -p %{buildroot}%{_libdir}/%{name}
install -Dpm755 -t %{buildroot}%{_libdir}/%{name}/ libprjoxide/target/release/*.so

# bins
mkdir -p %{buildroot}%{_bindir}/
install -Dpm755 -t %{buildroot}%{_bindir}/ libprjoxide/target/release/prjoxide

# database
mkdir -p %{buildroot}%{_datadir}/%{name}/database
find database/ -type f -exec install -D {} %{buildroot}%{_datadir}/%{name}/database/{} \;


%files
%doc README.md
%doc docs
%{_bindir}/*
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/lib*.so

%files devel
%doc tools
%doc examples

%files data
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/database

%changelog
* Sat Feb 06 2021 Cristian Balint <cristian.balint@gmail.com>
- github upstream releases
